include MemReset.inc

;**********************CODE SEGMENT*********************************
.code

start:;PROG START HERE.
	invoke GetModuleHandle, NULL
	mov hInstance, eax

	;chWindows9xNotAllowed

	;Commit a page of storage and modify its contents.
	invoke VirtualAlloc,NULL, 1024, MEM_RESERVE OR MEM_COMMIT, PAGE_READWRITE
	mov pszData,eax
	invoke lstrcpy,pszData,addr szTestData
	
	invoke MessageBox,NULL, SADD("Do you want to access this data later?"), ADDR szAppName, MB_YESNO
	.IF EAX == IDNO
		;We want this page of storage to remain in our process but the 
        ; contents aren't important to us anymore. 
        ;Tell the system that the data is not modified.

        ; Note: Because MEM_RESET destroys data, VirtualAlloc rounds
        ; the base address and size parameters to their safest range.
        ; Here is an example: 
        ;    VirtualAlloc(pvData, 5000, MEM_RESET, PAGE_READWRITE)
        ; resets 0 pages on CPUs where the page size is greater than 4
        ;KB 
        ; and resets 1 page on CPUs with a 4 KB page. So that our call 
		;to 
        ;   VirtualAlloc to reset memory below always succeeds, 
		;VirtualQuery 
        ; is called first to get the exact region size.
		invoke VirtualQuery, pszData,addr mbi, sizeof mbi
		invoke VirtualAlloc, pszData, mbi.RegionSize, MEM_RESET, PAGE_READWRITE
	.endif
	
	;Commit as much storage as there is physical RAM.
	invoke GlobalMemoryStatus,addr mst
	invoke VirtualAlloc,NULL, mst.dwTotalPhys, 
      MEM_RESERVE OR MEM_COMMIT, PAGE_READWRITE
 	mov pvDummy,eax
 	
 	;Touch all the pages in the dummy region so that any
    ; modified pages in RAM are written to the paging file.
    invoke RtlZeroMemory,pvDummy, mst.dwTotalPhys
    
    ;Compare our data page with what we originally wrote there.
    invoke lstrcmp,pszData,addr szTestData
    .if eax == 0
    	
    	;The data in the page matches what we originally put there.
        ; ZeroMemory forced our page to be written to the paging file.
        invoke MessageBox,NULL, SADD("Modified data page was saved."), ADDR szAppName, MB_OK
        
     .ELSE    
     	;The data in the page does NOT match what we originally put 
		;there
        ; ZeroMemory didn't cause our page to be written to the paging 
		;file
		INVOKE MessageBox,NULL,SADD("Modified data page was NOT saved."), ADDR szAppName, MB_OK
    .ENDIF	
 	        
	invoke ExitProcess,eax

end start
